//Grenader.cs;

datablock AudioProfile(GrenaderFireSound)
{
   filename    = "./crackerL_fire.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ParticleData(GrenaderSmoke2Particle)
{
	dragCoefficient      = 5;
	gravityCoefficient   =0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "1 0.2 0.0 0";
	colors[1]     = "1 0.5 0 0.9";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 0.45;
   sizes[1]      = 0.9;
	sizes[2]      = 0.25;

   times[0] = 0.0;
   times[1] = 0.2;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(GrenaderSmoke2Emitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 40.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GrenaderSmoke2Particle";
};

datablock ParticleData(GrenadeSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1200;
	lifetimeVarianceMS   = 350;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.5 0.5 0.5 0.0";
	colors[1]     = "0.5 0.5 0.5 0.1";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 1.55;
   sizes[1]      = 0.3;
	sizes[2]      = 0.0;

   times[0] = 0.0;
   times[1] = 0.38;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(GrenadeSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "GrenadeSmokeParticle";
};

datablock DebrisData(GrenaderDebris)
{
	shapeFile = "./GrenadeL.2.dts";
	lifetime = 3.0;
	minSpinSpeed = -1900.0;
	maxSpinSpeed = 900.0;
	elasticity = 0.2;
	friction = 0.1;
	numBounces = 4;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 1;
};

datablock ExplosionData(GrenaderExplosion : RPGExplosion)
{
   //explosionShape = "";

   explosionShape = "./explosionSphere1.dts";

   damageRadius = 15;
   radiusDamage = 60;

   impulseRadius = 16;
   impulseForce = 5000;
};

AddDamageType("GrenaderDirect",   '<bitmap:add-ons/weapon_package_tw/Content/Guns/explosives/CI_Grenade_launcher> %1',    '%2 <bitmap:add-ons/weapon_package_tw/Content/Guns/explosives/CI_Grenade_launcher> %1',1,1);
datablock ProjectileData(GrenaderProjectile)
{
   projectileShapeName = "./grenade_projectile.1.dts";
   directDamage        = 30;
   directDamageType = $DamageType::GrenaderDirect;
   radiusDamageType = $DamageType::GrenaderDirect;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = GrenaderExplosion;
   particleEmitter     = GrenadeSmokeEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 50;             
   brickExplosionMaxVolume = 76;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 98;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 115;
   velInheritFactor    = 0.0;

   armingDelay         = 400;
   lifetime            = 400;
   fadeDelay           = 300;
   bounceElasticity    = 0.2;
   bounceFriction      = 1.00;
   isBallistic         = true;
   gravityMod = 1;
   explodeOnPlayerImpact = true;
   explodeondeath = true;

   hasLight    = false;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "GL Grenade";
};

//////////
// item //
//////////
datablock ItemData(GrenaderItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
   shapeFile = "./M79.DTS";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TW: Grenade Launcher";
	iconName = "./icon_Grenade";
	doColorShift = false;
	colorShiftColor = "0.40 0.40 0.42 1.000";
	l4ditemtype = "grenade";

	 // Dynamic properties defined by the scripts
	image = GrenaderImage;
	canDrop = true;

	maxAmmo = 1;
	canReload = 1;
	
	ammoType = "grenaderounds";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(GrenaderImage)
{
   // Basic Item properties
   shapeFile = "./M79.DTS";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = GrenaderItem;
   ammo = " ";
   projectile = GrenaderProjectile;
   projectileType = Projectile;

	casing = GrenaderDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 700;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = GrenaderItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.35;
	stateSequence[0]                	= "Reload";
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]				= TacticalDrawSound;

	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateTransitionOnNoAmmo[1]		= "Reload";
	stateScript[1]                  	= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.01;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                 	= "Fire";
	stateScript[2]                 		= "onFire";
	stateSound[2]				= GrenaderFireSound;
	stateWaitForTimeout[2]			= true;

	stateName[3]				= "Delay";
	stateTransitionOnTimeout[3]     	= "LoadCheckA";
	stateTimeoutValue[3]            	= 0.1;
	stateWaitForTimeout[3]			= true;
	stateSequence[3]                  	= "Reload";
	stateEmitterTime[3]			= 0.03;
	stateEmitterNode[3]			= "muzzleNode";
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 1.2;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	stateWaitForTimeout[6]			= true;
	stateSound[6]				= pullTriggerSound;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.4;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	stateWaitForTimeout[7]			= true;
	stateSound[7]				= RPGClickSound;
	
	stateName[10] 				= "Smoke";
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Delay";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.1;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";
};

function GrenaderImage::onFire(%this,%obj,%slot)
{
	if(%obj.client.quantity["grenaderounds"] <= 0 && %obj.toolAmmo[%obj.currTool] <= 0)
		%obj.unMountImage(%slot);
	else
	{
		Parent::onFire(%this,%obj,%slot);
		%obj.toolAmmo[%obj.currTool]--;
	}

	if(%obj.getDamagePercent() >= 1.0)
		return;

	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));

	%obj.playThread(2, plant);
}

function GrenaderImage::onReloadStart(%this,%obj,%slot)
{
    if(%obj.client.quantity["grenaderounds"] >= 1)
	{
		%obj.playThread(2, wrench);
	}
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function GrenaderImage::onActivate(%this,%obj,%slot)
{
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function GrenaderImage::onReady(%this,%obj,%slot)
{
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function GrenaderImage::onReloadWait(%this,%obj,%slot)
{
    if(%obj.client.quantity["grenaderounds"] >= 1)
	{
		%obj.playThread(2,shiftleft);
	}
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function GrenaderImage::onReloaded(%this,%obj,%slot)
{
    if(%obj.client.quantity["grenaderounds"] >= 1)
	{
		displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
		%obj.client.quantity["grenaderounds"]--;
		%obj.toolAmmo[%obj.currTool]++;
		%obj.setImageAmmo(%slot,1);
	}
}