//RPG.cs

//audio
datablock AudioProfile(RPGFireSound)
{
   filename    = "./rpg_launch.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(RPGClickSound)
{
   filename    = "./rpg_click.1.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(PullTriggerSound)
{
   filename    = "./pull_trigger.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(LauncherDiscardSound)
{
   filename    = "./launcher_discard.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(RPGExplodeSound)
{
   filename    = "./grenade_blast_2.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(RPGLoopSound)
{
   filename    = "./rpg_Loop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};

datablock DebrisData(RPGDebris)
{
	shapeFile = "./missilelauncher.dts";
	lifetime = 3.0;
	minSpinSpeed = -1900.0;
	maxSpinSpeed = 900.0;
	elasticity = 0.2;
	friction = 0.1;
	numBounces = 4;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 1;
};

datablock ParticleData(RPGSmoke2Particle)
{
	dragCoefficient      = 5;
	gravityCoefficient   =0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "1 0.2 0.0 0.6";
	colors[1]     = "1 0.5 0 0.9";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 0.85;
   sizes[1]      = 0.0;
	sizes[2]      = 0.25;

   times[0] = 0.0;
   times[1] = 0.1;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RPGSmoke2Emitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = -30.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RPGSmoke2Particle";
};

datablock ParticleData(RPGSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   =0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 800;
	lifetimeVarianceMS   = 00;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;

   colors[0]     = "0.9 0.9 0.9 0.1";
	colors[1]     = "0.9 0.9 0.9 0.1";
	colors[2]     = "0.5 0.5 0.5 0.0";

	sizes[0]      = 1.25;
   sizes[1]      = 1.3;
	sizes[2]      = 0.25;

   times[0] = 0.0;
   times[1] = 0.01;
   times[2] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RPGSmokeEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 25;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RPGSmokeParticle";
};

datablock ParticleData(RPGExplosionParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 800;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 5.0;
	spinRandomMin		= -5.0;
	spinRandomMax		= 5.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/cloud";
	//animTexName		= "~/data/particles/cloud";

	// Interpolation variables
   colors[0]     = "0.9 0.5 0.0 0.6";
   colors[1]     = "0.1 0.05 0.025 0.4";
   colors[2]     = "0.1 0.05 0.025 0.0";

	sizes[0]	= 18.0;
	sizes[1]	= 15.0;
   sizes[2]	= 15.5;

	times[0]	= 0.0;
	times[1]	= 0.28;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(RPGExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 90;
   overrideAdvance = false;
   particles = "RPGExplosionParticle";
};

datablock ParticleData(RPGExplosionParticle2)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= -0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 2000;
	lifetimeVarianceMS	= 1990;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
   colors[0]     = "1 0.5 0.0 1";
   colors[1]     = "0.9 0.4 0.0 0.8";
   colors[2]     = "1 1 1 0.0";

	sizes[0]	= 0.2;
	sizes[1]	= 0.2;
   sizes[2]	= 0.2;

	times[0]	= 0.0;
	times[1]	= 0.1;
   times[2]	= 1.0;
};

datablock ParticleEmitterData(RPGExplosionEmitter2)
{
   ejectionPeriodMS = 4;
   periodVarianceMS = 0;
   lifetimeMS       = 120;
   ejectionVelocity = 12;
   velocityVariance = 12.0;
   ejectionOffset   = 1.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RPGExplosionParticle2";
};


datablock ParticleData(RPGExplosionRingParticle)
{
   dragCoefficient      = 8;
   gravityCoefficient   = -0.5;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 100;
   lifetimeVarianceMS   = 10;
   textureName          = "base/data/particles/star1";
   spinSpeed        = 10.0;
   spinRandomMin        = -500.0;
   spinRandomMax        = 500.0;
   colors[0]     = "1.0 1.0 0.6 1";
   colors[1]     = "1.0 1.0 0.6 1";
   sizes[0]      = 19;
   sizes[1]      = 22;

   useInvAlpha = false;
};

datablock ParticleEmitterData(RPGExplosionRingEmitter)
{
   lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RPGExplosionRingParticle";
};


datablock ExplosionData(RPGExplosion)
{
   //explosionShape = "";
   explosionShape = "./explosionSphere1.dts";
	soundProfile = RPGExplodeSound;

   lifeTimeMS = 150;

   particleEmitter = RPGExplosionEmitter2;
   particleDensity = 60;
   particleRadius = 0.2;

   emitter[0] = RPGExplosionRingEmitter;
  emitter[1] = RPGExplosionEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "3.0 10.0 3.0";
   camShakeDuration = 0.5;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 20;
   lightStartColor = "1 1 1 1";
   lightEndColor = "0 0 0 0";

   damageRadius = 2;
   radiusDamage = 100;

   impulseRadius = 2;
   impulseForce = 800;
};

AddDamageType("RPGDirect",   '<bitmap:add-ons/Weapon_Package_TW/Content/Guns/Explosives/CI_RPG> %1',    '%2 <bitmap:add-ons/Weapon_Package_TW/Content/Guns/Explosives/CI_RPG> %1',1,1);
datablock ProjectileData(RPGProjectile)
{
   projectileShapeName = "add-ons/weapon_rocket_launcher/RocketProjectile.dts";
   directDamage        = 200;
   directDamageType = $DamageType::RPGDirect;
   radiusDamageType = $DamageType::RPGDirect;
   impactImpulse	   = 1000;
   verticalImpulse	   = 1000;
   explosion           = RPGExplosion;
   particleEmitter     = RPGSmokeEmitter;

   brickExplosionRadius = 3;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 30;             
   brickExplosionMaxVolume = 30;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 60;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   sound = RPGLoopSound;

   muzzleVelocity      = 10;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 14000;
   fadeDelay           = 13500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.05;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "1 0.5 0.0";

   uiName = "Rocket-Propelled Grenade";
};

//////////
// item //
//////////
datablock ItemData(RPGItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./rpg.DTS";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TW: RPG";
	iconName = "./icon_RPG";
	doColorShift = false;
	colorShiftColor = "0.200 0.200 0.200 1.000";
	l4ditemtype = "grenade";

	 // Dynamic properties defined by the scripts
	image = RPGImage;
	canDrop = true;

	maxAmmo = 1;
	canReload = 1;
	ammoType = "rocketrounds";
	usesAmmo = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RPGImage)
{
   // Basic Item properties
   shapeFile = "./rpg.DTS";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = RPGItem;
   ammo = " ";
   projectile = RPGProjectile;
   projectileType = Projectile;

	casing = RPGDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 700;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = RPGItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.35;
	stateSequence[0]               		= "Reload";
	stateTransitionOnTimeout[0]       	= "LoadCheckA";
	stateSound[0]						= TacticalDrawSound;

	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateTransitionOnNoAmmo[1]			= "Reload";
	stateScript[1]                  	= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.01;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                 	= "Fire";
	stateScript[2]                  	= "onFire";
	stateSound[2]						= RPGFireSound;
	stateWaitForTimeout[2]				= true;

	stateName[3]						= "Delay";
	stateTransitionOnTimeout[3]     	= "LoadCheckA";
	stateTimeoutValue[3]            	= 0.1;
	stateWaitForTimeout[3]				= true;
	stateSequence[3]                 	= "Reload";
	stateEmitterTime[3]					= 0.03;
	stateEmitterNode[3]					= "muzzleNode";
	
	stateName[4]						= "LoadCheckA";
	stateScript[4]						= "onLoadCheck";
	stateTimeoutValue[4]				= 0.01;
	stateTransitionOnTimeout[4]			= "LoadCheckB";
	
	stateName[5]						= "LoadCheckB";
	stateTransitionOnAmmo[5]			= "Ready";
	stateTransitionOnNoAmmo[5]			= "Reload";

	stateName[6]						= "Reload";
	stateTimeoutValue[6]				= 1.5;
	stateScript[6]						= "onReloadStart";
	stateTransitionOnTimeout[6]			= "Wait";
	stateWaitForTimeout[6]				= true;
	stateSound[6]						= PullTriggerSound;
	
	stateName[7]						= "Wait";
	stateTimeoutValue[7]				= 0.4;
	stateScript[7]						= "onReloadWait";
	stateTransitionOnTimeout[7]			= "Reloaded";
	stateWaitForTimeout[7]				= true;
	stateSound[7]						= RPGClickSound;
	
	stateName[10] 						= "Smoke";
	stateEmitterTime[10]				= 0.3;
	stateEmitterNode[10]				= "muzzleNode";
	stateTimeoutValue[10]				= 0.2;
	stateTransitionOnTimeout[10]		= "Delay";
	
	stateName[12]						= "Reloaded";
	stateTimeoutValue[12]				= 0.4;
	stateScript[12]						= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";
};

function RPGImage::onFire(%this, %obj, %slot)
{
	if(%obj.getDamagePercent() >= 1.0)
		return;
		
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));

	if(%obj.client.quantity["rocketRounds"] <= 0 && %obj.toolAmmo[%obj.currTool] <= 0)
		%obj.unMountImage(%slot);
	else
	{
		%obj.toolAmmo[%obj.currTool]--;
	
	%obj.playThread(2, shiftAway);

	%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");
	
          serverPlay3D(RPGFireSound,%obj.getPosition());
	%projectile = %this.projectile;
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%spread = 0.0001;
	}
	else
	{
		%spread = 0;
	}

	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};

	%p.swirlvel=%vector;

	%p.shot=getsimtime()/500;
	%p.scale="1 1 1";
	%p.swirls = schedule(300,0,"GunBulletSwirl",%p,%obj,%slot);
	}
}

function RPGImage::onReloadStart(%this,%obj,%slot)
{
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
	%obj.playThread(2, wrench);
}

function RPGImage::onActivate(%this,%obj,%slot)
{
		displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function RPGImage::onReady(%this,%obj,%slot)
{
		displayAmmo(%obj.client, %obj, %obj.getMountedImage(0)); 
}

function RPGImage::onReloadWait(%this,%obj,%slot)
{
	%obj.playThread(2,shiftleft);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function RPGImage::onReloaded(%this,%obj,%slot)
{
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
	%obj.client.quantity["rocketrounds"]--;
	%obj.toolAmmo[%obj.currTool]++;
	%obj.setImageAmmo(%slot,1);
}

function gunbulletswirl(%p,%obj,%slot){
if(!isobject(%p)){return;}
%sub = (getsimtime()/1000 - %p.shot);
if(%sub>%p.getdatablock().lifetime||$ENDITDAMNIT){%p.delete();return;}
//echo(%sub SPC %p.shot SPC %p.getdatablock().lifetime SPC getsimtime()/1000);
%speed = 0;
%projectile = "rpgprojectile";
if(%projectile$="normal"){
%projectile="gunprojectile";
}
//echo(%projectile);
%spread = "0.0078";

%vector = %p.swirlvel;
%objectVelocity = "0 0 0";
%vector1 = VectorScale(%vector, 50);
//echo(%vector1 SPC %projectile.muzzlevelocity SPC %projectile.muzzleVelocity+%speed);
%vector2 = VectorScale(%objectVelocity, 1);
%velocity = VectorAdd(%vector1,%vector2);
%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
%velocity = MatrixMulVector(%mat, %velocity);

%pos=%p.getposition();

%offsetf=0;

%ox2 = getword(%offsetf,0);%oy2 = getword(%offsetf,1);%oz2 = getword(%offsetf,2);
%ox2=getrandom(%ox2 * -1, %ox2);%oy2=getrandom(%oy2 * -1, %oy2);%oz2=getrandom(%oz2 * -1, %oz2);
%ox2/=100;%oy2/=100;%oz2/=100;

if($GUNSWIRLCONSTRAIN==2){
if(%ox2==getword(%p.lastoff,0)){
%ox2=getword(%p.lastoff,0)* -1;
}
if(%oy2==getword(%p.lastoff,1)){
%oy2=getword(%p.lastoff,1)* -1;
}
if(%oz2==getword(%p.lastoff,2)){
%oz2=getword(%p.lastoff,2)* -1;
}
}

%offpos2=%ox2 SPC %oy2 SPC %oz2;
if($GUNSWIRLCONSTRAIN==1){
%offpos2=vectoradd(%offpos2,getword(%p.lastoff,0) * -1 SPC getword(%p.lastoff,2) * -1 SPC getword(%p.lastoff,2) * -1 );
}
//echo($GUNSWIRLCONSTRAIN);

%newpos=vectoradd(%pos,%offpos2);
%p2 = new (projectile)()
{
dataBlock = %projectile;
initialVelocity = %velocity;
initialPosition = %newpos;
sourceObject = %obj;
sourceSlot = %slot;
client = %obj.client;
};
MissionCleanup.add(%p2);
%p2.setscale(%p.scale);
%p2.scale=%p.scale;
%p2.swirlvel=%p.swirlvel;
%p.shot-=5;
%p2.shot=%p.shot;
%p2.lastoff=%offpos2;
%p2.swirls = schedule(100,0,"GunBulletSwirl",%p2,%obj,%slot);
%p.delete();
}

function RPGProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
cancel(%this.swirls);
cancel(%obj.swirls);

Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}

