// Projectile data
AddDamageType("Magnum",   '<bitmap:add-ons/Weapon_Package_TW/Content/Guns/Pistols/CI_Magnum> %1',    '%2 <bitmap:add-ons/Weapon_Package_TW/Content/Guns/Pistols/CI_Magnum> %1',0.75,1);

// Item Data
datablock ItemData(MagnumItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./MAGNUM.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TW: Magnum";
	iconName = "icon_Magnum";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = MagnumImage;
	canDrop = true;
	
	isRyWeapon = 1;
	maxAmmo = 6;
	canReload = 1;
	ammoType = "magnumRounds";
	usesAmmo = 1;
};

// Weapon Image
datablock ShapeBaseImageData(MagnumImage)
{
   // Basic Item properties
   shapeFile = "./MAGNUM.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MagnumItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = Magnumse;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = MagnumItem.colorShiftColor;

  // Rykuta's Epic Stuffings
   // Recoil - - - - - - - - - - - -
	recoilType = "Heavy";		// Type of recoil, (Heavy, Normal, Light).
	recoilMovementRate = 2;		// Multiplyer of recoil based on movement.
	recoilRemoveDelay = 1000;	// Time in MS until recoil begins to decrement.
	recoilAddRate = 0.0015;	// Amount added to the recoil after firing has commenced.
	//recoilSubRate = 0.0004	// Amount subtracted to the recoil after firing has ceased. (Not Yet Used)
	//recoilCrouchRedux = 2;	// Divide Recoil By This Reduction when Crouching.
	defaultSpreadAmt = 0.0002;	// Default spread.
	maxRecoil = 0.005;			// Highest the recoil can reach.
	usesBiPod = 0;				// Does it have a bipod application?
	biPodRecoilReduct = 2;		// Divide Recoil by this reduction when Bipod is deployed.
   // Other - - - - - - - - - - - -
	fireAnim = "ShiftAway";
   // Damage - - - - - - - - - - - 
	baseDamage = 36; 				//Base damage the weapon deals
	nodeDamageMultiHead = 1.5; 		// Ammount the damage is multiplied when a headshot is achieved.
	nodeDamageMultiLimbs = 0.75; 	// Ammount the damage is multiplied when the limbs are hit.   

	// Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   raycastWeaponRange = 200; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = GunProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 15;
   raycastDirectDamageType = $DamageType::Magnum;
   raycastSpreadAmt = 0.00125; //varies
   raycastSpreadCount = 1;
   raycastTracerProjectile = TacticalTracerProjectile;
   raycastFromMuzzle = true;

	// Main gun functionality

	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.2;
	stateTransitionOnTimeout[0]       	= "FireLoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "TacticalDrawSound";
	StateScript[0]						= "onEquiped";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.05;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  	= true;
	stateEmitter[2]				= gunFlashEmitter;
	stateEmitterTime[2]			= 0.075;
	stateEmitterNode[2]			= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	StateSequence[2]			= "fire";
	stateSound[2]				= MagnumFireSound;

	stateName[3] 				= "Smoke";
	stateEmitter[3]				= gunSmokeEmitter;
	stateEmitterTime[3]			= 0.3;
	stateEmitterNode[3]			= "muzzleNode";
	stateTimeoutValue[3]			= 0.2;
	stateTransitionOnTimeout[3]		= "FireLoadCheckA";

	// Reload checks
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";

	stateName[6]				= "FireLoadCheckA";
	stateScript[6]				= "onLoadCheck";
	stateTimeoutValue[6]			= 0.01;
	stateTransitionOnTimeout[6]		= "FireLoadCheckB";
	
	stateName[7]				= "FireLoadCheckB";
	stateTransitionOnAmmo[7]		= "WaitForTriggerUp";
	stateTransitionOnNoAmmo[7]		= "Reload";

	stateName[8]				= "WaitForTriggerUp";
	stateSequence[8]                	= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[8]     	= "Ready";
	stateScript[8]				= "WaitForTriggerUp";

	// Regular Reload

	stateName[9]				= "Reload";
	stateScript[9]				= "onReloading";
	stateTimeoutValue[9]			= 2.5;
	stateTransitionOnTimeout[9]     	= "ReloadFinish";
	stateWaitForTimeout[9]			= true;
	StateSequence[9]			= "reload";
	stateSound[9]				= MagnumReloadSound;

	// This is the only weapon with a single reload

	stateName[10]				= "ReloadFinish";
	stateScript[10]				= "ReloadComplete";
	stateTimeoutValue[10]			= 0.01;
	stateTransitionOnTimeout[10]     	= "Ready";
	stateWaitForTimeout[10]			= true;

};

function MagnumImage::OnReloading(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	schedule(200,0,TWAnimD,%obj);
	schedule(450,0,TWAnimC,%obj);
	schedule(450,0,TWAnimC,%obj);
	schedule(1240,0,TWAnimB,%obj);
	schedule(1340,0,TWAnimB,%obj);
	schedule(2000,0,TWAnimE,%obj);

	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function MagnumImage::onMount(%this,%obj,%slot)
{
   	Parent::onMount(%this,%obj,%slot);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function MagnumImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}

function MagnumImage::WaitForTriggerUp(%this, %obj, %slot)
{
	%obj.playThread(2, plant);	
}