// Projectile data
AddDamageType("Carbine",   '<bitmap:add-ons/Weapon_Package_TW/Content/Guns/Rifles/CI_Carbine> %1',    '%2 <bitmap:add-ons/Weapon_Package_TW/Content/Guns/Rifles/CI_Carbine> %1',0.75,1);

// Item Data
datablock ItemData(CarbineItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Carbine Item Properties
	shapeFile = "./Carbine.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TW: M14-EBR Carbine";
	iconName = "./Icon_Carbine";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	Image = CarbineImage;
	canDrop = true;
	
	maxAmmo = 15;
	canReload = 1;
	ammoType = "rifleRounds";
	isRyWeapon = true;
	usesAmmo = 1;
};

// Weapon Image
datablock ShapeBaseImageData(CarbineImage)
{
   // Carbine Item properties
   shapeFile = "./Carbine.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = CarbineItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = CarbineItem.colorShiftColor;  
   
  // Rykuta's Epic Stuffings
   // Recoil - - - - - - - - - - - -
	recoilType = "Normal";		// Type of recoil, (Heavy, Normal, Light).
	recoilMovementRate = 2;		// Multiplyer of recoil based on movement.
	recoilRemoveDelay = 1000;	// Time in MS until recoil begins to decrement.
	recoilAddRate = 0.0003;		// Amount added to the recoil after firing has commenced.
	//recoilSubRate = 0.0004	// Amount subtracted to the recoil after firing has ceased. (Not Yet Used)
	//recoilCrouchRedux = 2;	// Divide Recoil By This Reduction when Crouching.
	defaultSpreadAmt = 0.0001;	// Default spread.
	maxRecoil = 0.005;		// Highest the recoil can reach.
	usesBiPod = 0;			// Does it have a bipod application?
	biPodRecoilReduct = 2;		// Divide Recoil by this reduction when Bipod is deployed.
   // Other - - - - - - - - - - - -
	fireAnim = "Plant";
   // Damage - - - - - - - - - - - 
	baseDamage = 22; 		//Base Damage the weapon deals
	nodeDamageMultiHead = 1.75; 	// Ammount the Damage is multiplied when a headshot is achieved.
	nodeDamageMultiLimbs = 0.75; 	// Ammount the Damage is multiplied when the limbs are hit.

	// Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports Carbine ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   raycastWeaponRange = 200; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = GunProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 15;
   raycastDirectDamageType = $DamageType::Carbine;
   raycastSpreadAmt = 0.0001; //varies
   raycastSpreadCount = 1;
   raycastTracerProjectile = TacticalTracerProjectile;
   raycastFromMuzzle = true;

	// Main gun functionality

	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "FireLoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "TacticalDrawSound";
	StateScript[0]						= "onEquiped";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "ReloadPause";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.01;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       		  	= true;
	stateEmitter[2]						= gunFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= RifleFireASound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.3;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.2;
	stateTransitionOnTimeout[3]			= "FireLoadCheckA";

	// Reload checks
	
	stateName[4]						= "LoadCheckA";
	stateScript[4]						= "onLoadCheck";
	stateTimeoutValue[4]				= 0.01;
	stateTransitionOnTimeout[4]			= "LoadCheckB";
	
	stateName[5]						= "LoadCheckB";
	stateTransitionOnAmmo[5]			= "Ready";
	stateTransitionOnNoAmmo[5]			= "Reload";

	stateName[6]						= "FireLoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.01;
	stateTransitionOnTimeout[6]			= "FireLoadCheckB";
	
	stateName[7]						= "FireLoadCheckB";
	stateTransitionOnAmmo[7]			= "WaitForTriggerUp";
	stateTransitionOnNoAmmo[7]			= "ReloadPauseFull";

	stateName[8]						= "WaitForTriggerUp";
	stateScript[8]						= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[8]		= "Ready";

	// Reloads (These are special, since this time, cocking the gun is only nessisary if you run out of ammo)

	// Regular Reload

	stateName[9]						= "Reload";
	stateScript[9]						= "onReloading";
	stateTimeoutValue[9]				= 0.75;
	stateTransitionOnTimeout[9]     	= "InsertClipA";
	stateWaitForTimeout[9]				= true;
	StateSequence[9]					= "reload";
	stateSound[9]						= CarbineClipOutSound;
	
	stateName[10]						= "InsertClipA";
	stateScript[10]						= "OnClipInserted";
	stateTimeoutValue[10]				= 0.625;
	stateTransitionOnTimeout[10]     	= "ReloadFinish";
	stateWaitForTimeout[10]				= true;
	stateSound[10]						= CarbineClipInSound;

	// Full Reload

	stateName[11]						= "ReloadFull";
	stateScript[11]						= "onReloading";
	stateTimeoutValue[11]				= 0.75;
	stateTransitionOnTimeout[11]     	= "InsertClipB";
	stateWaitForTimeout[11]				= true;
	stateSound[11]						= CarbineClipOutSound;

	stateName[12]						= "InsertClipB";
	stateScript[12]						= "onClipInserted";
	stateTimeoutValue[12]				= 0.625;
	stateTransitionOnTimeout[12]     	= "CockGun";
	stateWaitForTimeout[12]				= true;
	stateSound[12]						= CarbineClipInSound;

	stateName[13]						= "CockGun";	// Try not to laugh
	stateScript[13]						= "onGunCock";
	stateTimeoutValue[13]				= 0.5;
	stateTransitionOnTimeout[13]     	= "ReloadFinish";
	stateWaitForTimeout[13]				= true;
	stateSound[13]						= CarbineCockSound;	

	// Finish reloading
	stateName[14]						= "ReloadFinish";
	stateScript[14]						= "ReloadComplete";
	stateTimeoutValue[14]				= 0.01;
	stateTransitionOnTimeout[14]     	= "Ready";
	stateWaitForTimeout[14]				= true;

	// Reload pauses
	stateName[15]						= "ReloadPause";
	stateTimeoutValue[15]				= 0.1;
	stateTransitionOnTimeout[15]     	= "Reload";
	stateWaitForTimeout[15]				= true;

	stateName[16]						= "ReloadPauseFull";
	stateTimeoutValue[16]				= 0.1;
	stateTransitionOnTimeout[16]     	= "ReloadFull";
	stateWaitForTimeout[16]				= true;
};


function CarbineImage::OnReloading(%this,%obj,%slot)
{
	%obj.playThread(2, shiftright);
	schedule(150,0,TWAnimA,%obj);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function CarbineImage::onClipInserted(%this,%obj,%slot)
{
	%obj.playThread(2, shiftright);
	schedule(100,0,TWAnimB,%obj);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function CarbineImage::onGunCock(%this,%obj,%slot)
{
	%obj.playThread(2, shiftleft);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function CarbineImage::onMount(%this,%obj,%slot)
{
   	Parent::onMount(%this,%obj,%slot);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function CarbineImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}