// Item Data
datablock ItemData(OlympiaItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 //  Item Properties
	shapeFile = "./Olympia.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TW: Olmypia";
	iconName = "./ICON_OLYMPIA";
	doColorShift = true;
	colorShiftColor = "0.51 0.43 0.36 1";

	 // Dynamic properties defined by the scripts
	image = OlympiaImage;
	canDrop = true;
	
	maxAmmo = 2;
	canReload = 1;
	ammoType = "ShotgunRounds";
	usesAmmo = 1;
	isRyWeapon = 1;
};

AddDamageType("Olympia",   '<bitmap:add-ons/Weapon_Package_TW/Content/Guns/Shotguns/CI_OLYMPIA> %1',    '%2 <bitmap:add-ons/Weapon_Package_TW/Content/Guns/Shotguns/CI_OLYMPIA> %1',0.75,1);

// Weapon Image
datablock ShapeBaseImageData(OlympiaImage)
{
   //  Item properties
   shapeFile = "./Olympia.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = OlympiaItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   casing = ShotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   // Rykuta's Epic Stuffings
   // Recoil - - - - - - - - - - - -
	recoilType = "Heavy";		// Type of recoil, (Heavy, Normal, Light).
	recoilMovementRate = 3;		// Multiplyer of recoil based on movement.
	recoilRemoveDelay = 750;	// Time in MS until recoil begins to decrement.
	recoilAddRate = 0.0015;		// Amount added to the recoil after firing has commenced.
	//recoilSubRate = 0.0004	// Amount subtracted to the recoil after firing has ceased. (Not Yet Used)
	//recoilCrouchRedux = 2;	// Divide Recoil By This Reduction when Crouching.
	defaultSpreadAmt = 0.003;	// Default spread.
	maxRecoil = 0.01;		// Highest the recoil can reach.
	usesBiPod = 0;			// Does it have a bipod application?
	biPodRecoilReduct = 2;		// Divide Recoil by this reduction when Bipod is deployed.
   // Other - - - - - - - - - - - -
	fireAnim = "ShiftAway";
   // Damage - - - - - - - - - - - 
	baseDamage = 8; 		//Base damage the weapon deals
	nodeDamageMultiHead = 1.5; 	// Ammount the damage is multiplied when a headshot is achieved.
	nodeDamageMultiLimbs = 0.75; 	// Ammount the damage is multiplied when the limbs are hit.
   
   doColorShift = true;
   colorShiftColor = OlympiaItem.colorShiftColor;  

	// Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports  ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   raycastWeaponRange = 75; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = GunProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 5;
   raycastDirectDamageType = $DamageType::Olympia;
   raycastSpreadAmt = 0.001; //varies
   raycastSpreadCount = 8;
   raycastTracerProjectile = TacticalTracerProjectile;
   raycastFromMuzzle = true;

   	// Main gun functionality

	stateName[0]                    	= "Activate";
	stateTimeoutValue[0]            	= 0.5;
	stateSequence[0]					= "Activate";
	stateTransitionOnTimeout[0]     	= "Ready";
	stateSound[0]			  			= TacticalDrawSound;

	stateName[1]                    	= "Ready";
	stateTransitionOnTriggerDown[1] 	= "Fire";
	stateTransitionOnNoAmmo[1]			= "ReloadCheckA";
	stateAllowImageChange[1]			= true;
	stateSequence[1]					= "ready";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.02;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]		 	 	= true;
	stateEmitter[2]			  			= gunFlashEmitter;
	stateEmitterTime[2]		  			= 0.05;
	stateEmitterNode[2]		  			= "muzzleNode";
	stateSound[2]			  			= ShotgunFireCSound;

	stateName[3] 			  			= "Smoke";
	stateEmitter[3]			  			= gunSmokeEmitter;
	stateEmitterTime[3]		  			= 0.1;
	stateEmitterNode[3]		  			= "muzzleNode";
	stateTimeoutValue[3]            	= 0.2;
	stateTransitionOnTimeout[3]     	= "FireLoadCheckA";

	stateName[4]						= "ForceReloadWait";
	stateTimeoutValue[4]				= 0.5;
	stateTransitionOnTimeout[4]			= "ForceReload";
	stateWaitForTimeout[4]				= true;

	// Load checks

	// Special clip system makes these two states obsolete.

	//stateName[5]				= "LoadCheckA";
	//stateScript[5]			= "onLoadCheck";
	//stateTimeoutValue[5]			= 0.01;
	//stateTransitionOnTimeout[5]		= "LoadCheckB";
						
	//stateName[6]				= "LoadCheckB";
	//stateTransitionOnAmmo[6]		= "Ready";
	//stateTransitionOnNoAmmo[6]		= "ForceReload";
	
	stateName[7]						= "ReloadCheckA";
	stateScript[7]						= "onReloadCheck";
	stateTimeoutValue[7]				= 0.01;
	stateTransitionOnTimeout[7]			= "ReloadCheckB";
						
	stateName[8]						= "ReloadCheckB";
	stateTransitionOnAmmo[8]			= "Ready";
	stateTransitionOnNoAmmo[8]			= "Reload";

	// Full load checks (Clip is completely emptyied, no bullets loaded into chamber, requires a pump after reload)

	stateName[13]						= "FireLoadCheckA";
	stateScript[13]						= "onLoadCheck";
	stateTimeoutValue[13]				= 0.01;
	stateTransitionOnTimeout[13]		= "FireLoadCheckB";
						
	stateName[14]						= "FireLoadCheckB";
	stateTransitionOnAmmo[14]			= "Ready";
	stateTransitionOnNoAmmo[14]			= "ForceReloadWait";
	
	// Reloads
						
	stateName[9]						= "ForceReload";
	stateTransitionOnTimeout[9]     	= "ForceReloaded";
	stateTimeoutValue[9]				= 0.3;
	stateSequence[9]					= "Reload";
	stateSound[9]						= ShotgunReloadBSound;
	stateScript[9]						= "onReloadStart";
	
	stateName[10]						= "ForceReloaded";
	stateTransitionOnTimeout[10]     	= "ReloadCheckA";
	stateTimeoutValue[10]				= 0.2;
	stateScript[10]						= "onReloaded";
	
	stateName[11]						= "Reload";
	stateTransitionOnTimeout[11]   	  	= "Reloaded";
	stateTransitionOnTriggerDown[11]	= "Fire";
	stateWaitForTimeout[11]				= false;
	stateTimeoutValue[11]				= 0.3;
	stateSequence[11]					= "Reload";
	stateSound[11]						= ShotgunReloadBSound;
	stateScript[11]						= "onReloadStart";
	
	stateName[12]						= "Reloaded";
	stateTransitionOnTimeout[12]     	= "ReloadCheckA";
	stateTransitionOnTriggerDown[12]	= "Fire";
	stateWaitForTimeout[12]				= false;
	stateTimeoutValue[12]				= 0.2;
	stateScript[12]						= "onReloaded";
};

function OlympiaImage::onReloadStart(%this,%obj,%slot)
{
	%obj.playThread(2, shiftright);
	schedule(150,0,TWAnimB,%obj);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0)); 
}

function OlympiaImage::onReloaded(%this,%obj,%slot)
{
	%obj.client.quantity["Shotgunrounds"]--;
	%obj.toolAmmo[%obj.currTool]++;
   	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0)); 
}

function OlympiaImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0)); 
}
