//shell
datablock DebrisData(ShotgunShellDebris)
{
	shapeFile = "./SHOTGUN_SHELL.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};

// Projectile data
AddDamageType("PumpShotgun",   '<bitmap:add-ons/Weapon_Package_TW/Content/Guns/Shotguns/CI_PumpSHOTGUN> %1',    '%2 <bitmap:add-ons/Weapon_Package_TW/Content/Guns/Shotguns/CI_PumpSHOTGUN> %1',0.75,1);

// Item Data
datablock ItemData(PumpShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 //  Item Properties
	shapeFile = "./PumpShotgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TW: KSG-12 Shotgun";
	iconName = "./ICON_PumpSHOTGUN";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.5 1.000";

	 // Dynamic properties defined by the scripts
	image = PumpShotgunImage;
	canDrop = true;
	
	isRyWeapon = 1;
	maxAmmo = 6;
	canReload = 1;
	ammoType = "shotgunrounds";
	usesAmmo = 1;
};

// Weapon Image
datablock ShapeBaseImageData(PumpShotgunImage)
{
   //  Item properties
   shapeFile = "./PUMPSHOTGUN.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PumpShotgunItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   casing = ShotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = PumpShotgunItem.colorShiftColor;

  // Rykuta's Epic Stuffings
   // Recoil - - - - - - - - - - - -
	recoilType = "Heavy";		// Type of recoil, (Heavy, Normal, Light).
	recoilMovementRate = 2;		// Multiplyer of recoil based on movement.
	recoilRemoveDelay = 1000;	// Time in MS until recoil begins to decrement.
	recoilAddRate = 0.001;		// Amount added to the recoil after firing has commenced.
	//recoilSubRate = 0.0004	// Amount subtracted to the recoil after firing has ceased. (Not Yet Used)
	//recoilCrouchRedux = 2;	// Divide Recoil By This Reduction when Crouching.
	defaultSpreadAmt = 0.003;	// Default spread.
	maxRecoil = 0.01;		// Highest the recoil can reach.
	usesBiPod = 0;			// Does it have a bipod application?
	biPodRecoilReduct = 2;		// Divide Recoil by this reduction when Bipod is deployed.
   // Other - - - - - - - - - - - -
	fireAnim = "ShiftAway";
   // Damage - - - - - - - - - - - 
	baseDamage = 12; 		//Base damage the weapon deals
	nodeDamageMultiHead = 1.25; 	// Ammount the damage is multiplied when a headshot is achieved.
	nodeDamageMultiLimbs = 0.75; 	// Ammount the damage is multiplied when the limbs are hit.   

	// Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports  ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   raycastWeaponRange = 75; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = GunProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 5;
   raycastDirectDamageType = $DamageType::PumpShotgun;
   raycastSpreadAmt = 0.001; //varies
   raycastSpreadCount = 6;
   raycastTracerProjectile = TacticalTracerProjectile;
   raycastFromMuzzle = true;

   	// Main gun functionality

	stateName[0]                    	= "Activate";
	stateTimeoutValue[0]            	= 0.5;
	stateSequence[0]					= "Activate";
	stateTransitionOnTimeout[0]     	= "Ready";
	stateSound[0]			  			= TacticalDrawSound;

	stateName[1]                    	= "Ready";
	stateTransitionOnTriggerDown[1] 	= "Fire";
	stateTransitionOnNoAmmo[1]			= "ReloadCheckA";
	stateAllowImageChange[1]			= true;
	stateSequence[1]					= "ready";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.1;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= true;
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]		  		= true;
	stateEmitter[2]			  			= gunFlashEmitter;
	stateEmitterTime[2]		  			= 0.05;
	stateEmitterNode[2]		  			= "muzzleNode";
	stateSound[2]			  			= ShotgunfireASound;

	stateName[3] 			  			= "Smoke";
	stateEmitter[3]			  			= gunSmokeEmitter;
	stateEmitterTime[3]		  			= 0.1;
	stateEmitterNode[3]		  			= "muzzleNode";
	stateTimeoutValue[3]            	= 0.2;
	stateTransitionOnTimeout[3]     	= "Pump";

	stateName[4]			  			= "Pump";
	stateTimeoutValue[4]		  		= 0.5;
	stateTransitionOnTimeout[4]	  		= "FireLoadCheckA";
	stateWaitForTimeout[4]		  		= true;
	stateEjectShell[4]       	  		= true;
	stateSequence[4]					= "fire";
	stateSound[4]			  			= ShotgunPumpSound;
	stateScript[4]                  	= "onPump";

	// Load checks

	// Special clip system makes these two states obsolete.

	//stateName[5]				= "LoadCheckA";
	//stateScript[5]			= "onLoadCheck";
	//stateTimeoutValue[5]			= 0.01;
	//stateTransitionOnTimeout[5]		= "LoadCheckB";
						
	//stateName[6]				= "LoadCheckB";
	//stateTransitionOnAmmo[6]		= "Ready";
	//stateTransitionOnNoAmmo[6]		= "ForceReload";
	
	stateName[7]						= "ReloadCheckA";
	stateScript[7]						= "onReloadCheck";
	stateTimeoutValue[7]				= 0.01;
	stateTransitionOnTimeout[7]			= "ReloadCheckB";
						
	stateName[8]						= "ReloadCheckB";
	stateTransitionOnAmmo[8]			= "Ready";
	stateTransitionOnNoAmmo[8]			= "Reload";

	// Full load checks (Clip is completely emptyied, no bullets loaded into chamber, requires a pump after reload)

	stateName[13]						= "FireLoadCheckA";
	stateScript[13]						= "onLoadCheck";
	stateTimeoutValue[13]				= 0.01;
	stateTransitionOnTimeout[13]		= "FireLoadCheckB";
						
	stateName[14]						= "FireLoadCheckB";
	stateTransitionOnAmmo[14]			= "Ready";
	stateTransitionOnNoAmmo[14]			= "ForceFullReload";

	stateName[15]						= "FullReloadCheckA";
	stateScript[15]						= "onReloadCheck";
	stateTimeoutValue[15]				= 0.01;
	stateTransitionOnTimeout[15]		= "FullReloadCheckB";
						
	stateName[16]						= "FullReloadCheckB";
	stateTransitionOnAmmo[16]			= "ReloadPump";
	stateTransitionOnNoAmmo[16]			= "FullReload";

	// Reloads
						
	stateName[9]						= "ForceReload";
	stateTransitionOnTimeout[9]     	= "ForceReloaded";
	stateTimeoutValue[9]				= 0.3;
	stateSequence[9]					= "Reload";
	stateSound[9]						= ShotgunReloadSound;
	stateScript[9]						= "onReloadStart";
	
	stateName[10]						= "ForceReloaded";
	stateTransitionOnTimeout[10]     	= "ReloadCheckA";
	stateTimeoutValue[10]				= 0.2;
	stateScript[10]						= "onReloaded";
	
	stateName[11]						= "Reload";
	stateTransitionOnTimeout[11]     	= "Reloaded";
	stateTransitionOnTriggerDown[11]	= "Fire";
	stateWaitForTimeout[11]				= false;
	stateTimeoutValue[11]				= 0.3;
	stateSequence[11]					= "Reload";
	stateSound[11]						= ShotgunReloadSound;
	stateScript[11]						= "onReloadStart";
	
	stateName[12]						= "Reloaded";
	stateTransitionOnTimeout[12]     	= "ReloadCheckA";
	stateTransitionOnTriggerDown[12]	= "Fire";
	stateWaitForTimeout[12]				= false;
	stateTimeoutValue[12]				= 0.2;
	stateScript[12]						= "onReloaded";

	// Full reloads

	stateName[17]						= "ForceFullReload";
	stateTransitionOnTimeout[17]     	= "ForceFullReloaded";
	stateTimeoutValue[17]				= 0.3;
	stateSequence[17]					= "FullReload";
	stateSound[17]						= ShotgunReloadSound;
	stateScript[17]						= "onReloadStart";
	
	stateName[18]						= "ForceFullReloaded";
	stateTransitionOnTimeout[18]   	  	= "FullReloadCheckA";
	stateTimeoutValue[18]				= 0.2;
	stateScript[18]						= "onReloaded";
	
	stateName[19]						= "FullReload";
	stateTransitionOnTimeout[19]     	= "FullReloaded";
	stateTransitionOnTriggerDown[19]	= "Fire";
	stateWaitForTimeout[19]				= false;
	stateTimeoutValue[19]				= 0.3;
	stateSound[19]						= ShotgunReloadSound;
	stateScript[19]						= "onReloadStart";
	
	stateName[20]						= "FullReloaded";
	stateTransitionOnTimeout[20]     	= "FullReloadCheckA";
	stateWaitForTimeout[20]				= false;
	stateTimeoutValue[20]				= 0.2;
	stateScript[20]						= "onReloaded";

	// Secondary pump, for animation swaps

	stateName[21]			  			= "ReloadPump";
	stateTimeoutValue[21]		  		= 0.5;
	stateTransitionOnTimeout[21]	  	= "Ready";
	stateWaitForTimeout[21]		  		= true;
	stateEjectShell[21]       	  		= true;
	stateSequence[21]					= "fire";
	stateSound[21]			  			= ShotgunPumpSound;
	stateScript[21]                  	= "onPump";

	
};


function PumpShotgunImage::onPump(%this,%obj,%slot)
{
	%obj.playThread(2, shiftleft);
	schedule(250,0,TWAnimB,%obj);
	%obj.setImageAmmo(%slot,1);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));    
}

function PumpShotgunImage::onReloadStart(%this,%obj,%slot)
{
	%obj.playThread(2, shiftright);
	schedule(150,0,TWAnimB,%obj);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function PumpShotgunImage::onReloaded(%this,%obj,%slot)
{
	%obj.client.quantity["shotgunRounds"]--;
	%obj.toolAmmo[%obj.currTool]++;
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function PumpShotgunImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this,%obj,%slot);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}