// Projectile data
AddDamageType("HPSniper",   '<bitmap:add-ons/Weapon_Package_TW/Content/Guns/Snipers/CI_HPSniper> %1',    '%2 <bitmap:add-ons/Weapon_Package_TW/Content/Guns/Snipers/CI_HPSniper> %1',0.75,1);

// Item Data
datablock ItemData(HPSniperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./HPSniper.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TW: AS-50 HPSniper";
	iconName = "./ICON_HpSniper";
	doColorShift = true;
	colorShiftColor = "0.4 0.4 0.4 1.000";

	 // Dynamic properties defined by the scripts
	image = HPSniperImage;
	canDrop = true;
	
	maxAmmo = 5;
	canReload = 1;
	ammoType = "SniperRounds";
	usesAmmo = 1;
	isRyWeapon = 1;
};

// Weapon Image
datablock ShapeBaseImageData(HPSniperImage)
{
   // Basic Item properties
   shapeFile = "./HPSniper.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HPSniperItem;
   ammo = " ";
   projectile = gunProjectile;
   projectileType = Projectile;

   casing = GunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = HPSniperItem.colorShiftColor; 

  // Rykuta's Epic Stuffings
   // Recoil - - - - - - - - - - - -
	recoilType = "Heavy";		// Type of recoil, (Heavy, Normal, Light).
	recoilMovementRate = 5;		// Multiplyer of recoil based on movement.
	recoilRemoveDelay = 1000;	// Time in MS until recoil begins to decrement.
	recoilAddRate = 0.003;		// Amount added to the recoil after firing has commenced.
	//recoilSubRate = 0.0004	// Amount subtracted to the recoil after firing has ceased. (Not Yet Used)
	//recoilCrouchRedux = 2;	// Divide Recoil By This Reduction when Crouching.
	defaultSpreadAmt = 0.0015;	// Default spread.
	maxRecoil = 0.01;		// Highest the recoil can reach.
	usesBiPod = 1;			// Does it have a bipod application?
	biPodRecoilReduct = 5;		// Divide Recoil by this reduction when Bipod is deployed.
   // Other - - - - - - - - - - - -
	fireAnim = "ShiftAway";
   // Damage - - - - - - - - - - - 
	baseDamage = 50; 		//Base damage the weapon deals
	nodeDamageMultiHead = 2.25; 	// Ammount the damage is multiplied when a headshot is achieved.
	nodeDamageMultiLimbs = 0.75; 	// Ammount the damage is multiplied when the limbs are hit.   

	// Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.
   raycastWeaponRange = 400; //varies
   raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   raycastExplosionProjectile = GunProjectile;
   raycastExplosionBrickSound = bulletHitSound;
   raycastExplosionPlayerSound = bulletHitSound;
   raycastDirectDamage = 50;
   raycastDirectDamageType = $DamageType::HPSniper;
   raycastSpreadAmt = 0.001; //varies
   raycastSpreadCount = 1;
   raycastTracerProjectile = TacticalTracerProjectile;
   raycastFromMuzzle = true;
   raycastCritTracerProjectile = TacticalTracerProjectile;
   raycastCritDirectDamageType = $DamageType::HPSniperHeadshot;

	// Main gun functionality

	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.5;
	stateTransitionOnTimeout[0]       	= "FireLoadCheckA";
	StateSequence[0]					= "use";
	StateSound[0]						= "TacticalDrawSound";
	StateScript[0]						= "onEquiped";

	stateName[1]                     	= "Ready";
	stateTransitionOnNoAmmo[1]       	= "Reload";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateAllowImageChange[1]         	= true;
	stateScript[1]						= "onReady";

	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.1;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "fire";
	stateScript[2]                  	= "onFire";
	stateEjectShell[2]       	  		= true;
	stateEmitter[2]						= gunFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateWaitForTimeout[2]				= true;
	StateSequence[2]					= "fire";
	stateSound[2]						= SniperFireBSound;

	stateName[3] 						= "Smoke";
	stateEmitter[3]						= gunSmokeEmitter;
	stateEmitterTime[3]					= 0.3;
	stateWaitForTimeout[3]				= true;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]				= 0.3;
	stateTransitionOnTimeout[3]			= "BoltPull";

	stateName[15]						= "BoltPull";
	stateScript[15]						= "onGunCock";
	stateTimeoutValue[15]				= 0.5;
	stateTransitionOnTimeout[15]     	= "FireLoadCheckA";
	stateWaitForTimeout[15]				= true;
	stateSound[15]						= SniperBoltBSound;	

	// Reload checks
	
	stateName[4]						= "LoadCheckA";
	stateScript[4]						= "onLoadCheck";
	stateTimeoutValue[4]				= 0.01;
	stateTransitionOnTimeout[4]			= "LoadCheckB";
	
	stateName[5]						= "LoadCheckB";
	stateTransitionOnAmmo[5]			= "Ready";
	stateTransitionOnNoAmmo[5]			= "ReloadPause";

	stateName[6]						= "FireLoadCheckA";
	stateScript[6]						= "onLoadCheck";
	stateTimeoutValue[6]				= 0.01;
	stateTransitionOnTimeout[6]			= "FireLoadCheckB";
	
	stateName[7]						= "FireLoadCheckB";
	stateTransitionOnAmmo[7]			= "WaitForTriggerUp";
	stateTransitionOnNoAmmo[7]			= "ReloadPauseFull";

	stateName[8]						= "WaitForTriggerUp";
	stateSequence[8]                	= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[8]     	= "Ready";

	// Reloads (These are special, since this time, cocking the gun is only nessisary if you run out of ammo)

	// Regular Reload

	stateName[9]						= "Reload";
	stateScript[9]						= "onReloading";
	stateTimeoutValue[9]				= 0.8;
	stateTransitionOnTimeout[9]     	= "InsertClipA";
	stateWaitForTimeout[9]				= true;
	StateSequence[9]					= "reload";
	stateSound[9]						= SniperClipOutSound;
	
	stateName[10]						= "InsertClipA";
	stateScript[10]						= "OnClipInserted";
	stateTimeoutValue[10]				= 0.65;
	stateTransitionOnTimeout[10]     	= "ReloadFinish";
	stateWaitForTimeout[10]				= true;
	stateSound[10]						= SniperClipInSound;

	// Full Reload

	stateName[11]						= "ReloadFull";
	stateScript[11]						= "onReloading";
	stateTimeoutValue[11]				= 0.8;
	stateTransitionOnTimeout[11]     	= "InsertClipB";
	stateWaitForTimeout[11]				= true;
	stateSound[11]						= SniperClipOutSound;

	stateName[12]						= "InsertClipB";
	stateScript[12]						= "onClipInserted";
	stateTimeoutValue[12]				= 0.65;
	stateTransitionOnTimeout[12]     	= "CockGun";
	stateWaitForTimeout[12]				= true;
	stateSound[12]						= SniperClipInSound;

	stateName[13]						= "CockGun";	// Try not to laugh
	stateScript[13]						= "onGunCock";
	stateTimeoutValue[13]				= 0.5;
	stateTransitionOnTimeout[13]     	= "ReloadFinish";
	stateWaitForTimeout[13]				= true;
	stateSound[13]						= SniperBoltBSound;	

	// Finish reloading
	stateName[14]						= "ReloadFinish";
	stateScript[14]						= "ReloadComplete";
	stateTimeoutValue[14]				= 0.01;
	stateTransitionOnTimeout[14]     	= "Ready";
	stateWaitForTimeout[14]				= true;

	stateName[18]						= "ReloadPause";
	stateTimeoutValue[18]				= 0.2;
	stateTransitionOnTimeout[18]     	= "Reload";
	stateWaitForTimeout[18]				= true;

	stateName[19]						= "ReloadPauseFull";
	stateTimeoutValue[19]				= 0.2;
	stateTransitionOnTimeout[19]     	= "ReloadFull";
	stateWaitForTimeout[19]				= true;

};

function HPSniperImage::OnReloading(%this,%obj,%slot)
{
	%obj.playThread(2, shiftright);
	schedule(150,0,TWAnimA,%obj);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function HPSniperImage::onClipInserted(%this,%obj,%slot)
{
	%obj.playThread(2, shiftright);
	schedule(100,0,TWAnimB,%obj);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function HPSniperImage::onGunCock(%this,%obj,%slot)
{
	%obj.playThread(2, shiftLeft);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function HPSniperImage::onMount(%this,%obj,%slot)
{
   	Parent::onMount(%this,%obj,%slot);
	displayAmmo(%obj.client, %obj, %obj.getMountedImage(0));
}

function HPSniperImage::onUnMount(%this,%obj,%slot)
{
	Parent::onUnMount(%this,%obj,%slot);
	%obj.playThread(2, root);
	if(%obj.isBipodDeployed == 1)
	{
		//%player.playsound(BiPodDequipSound);
		%obj.popDatablock(NoMoveArmor.getID());
		//%player.playThread(2, plant);
		%obj.isBipodDeployed = 0;
	}
}