datablock ParticleData(TacticalTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 120;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/dot";
	//animTexName		= "~/data/particles/dot";

	// Interpolation variables
	colors[0]	= "1 1 0 1";
	colors[1]	= "1 1 0.4 1";
	colors[2]	= "1 1 1 1";
	sizes[0]	= 0.2;
	sizes[1]	= 0.15;
	sizes[2]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 0.5;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(TacticalTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = TacticalTrailParticle;

   useEmitterColors = true;
};

datablock ProjectileData(TacticalTracerProjectile)
{
   directDamage        = 0;
   directDamageType    = $DamageType::Gun;
   radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 100;
   verticalImpulse	  = 50;
//explosion           = gunExplosion;
   particleEmitter     = "TacticalTrailEmitter";

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 700;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.10;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

//we need the gun add-on for this, so force it to load
%error = ForceRequiredAddOn("Weapon_Gun");

if(%error == $Error::AddOn_Disabled)
{
	//we don't have the gun, so we're screwed
	error("ERROR: Weapon_Package_TW - required add-on Weapon_Gun not found!");
}
else
{
	// Engage Support Codes
	exec("./Content/Support/Support_RaycastingWeapons.cs");
	exec("./Content/Support/Support_AmmoGuns.cs");
	exec("./Content/Support/Support_AdvGuns.cs");
	exec("./Content/Support/Support_AltDatablock.cs");
   
	// Gun Sounds
	exec("./Sounds/Weapon_Sounds.cs");
   
	// Pistols
	exec("./Content/Guns/Pistols/Weapon_USP45.cs");
	exec("./Content/Guns/Pistols/Weapon_Deagle.cs");
	exec("./Content/Guns/Pistols/Weapon_Magnum.cs");
	
	// Rifles
	exec("./Content/Guns/Rifles/Weapon_M16.cs");
	exec("./Content/Guns/Rifles/Weapon_ACR.cs");
	exec("./Content/Guns/Rifles/Weapon_Carbine.cs");
	exec("./Content/Guns/Rifles/Weapon_Burster.cs");
	
	// Shotguns
	exec("./Content/Guns/Shotguns/Weapon_PumpShotgun.cs");
	exec("./Content/Guns/Shotguns/Weapon_Scattergun.cs");
	exec("./Content/Guns/Shotguns/Weapon_Olympia.cs");
	exec("./Content/Guns/Shotguns/Weapon_AutoShotgun.cs");
	exec("./Content/Guns/Shotguns/Weapon_RiotShotgun.cs");
   
	// Explosives
	exec("./Content/Guns/Explosives/Weapon_RPG.cs");
	exec("./Content/Guns/Explosives/Weapon_Grenade_Launcher.cs");
	exec("./Content/Guns/Explosives/Weapon_FragGrenade.cs");
	exec("./Content/Guns/Explosives/Weapon_StickGrenade.cs");
	
	// Snipers
	exec("./Content/Guns/Snipers/Weapon_CombatSniper.cs");
	exec("./Content/Guns/Snipers/Weapon_HPSniper.cs");	
	
	// SMGs
	exec("./Content/Guns/Smgs/Weapon_SubMachineGun.cs");
	exec("./Content/Guns/Smgs/Weapon_Ump45.cs");	
	exec("./Content/Guns/Smgs/Weapon_Mac10.cs");	
	
	// Others
	exec("./Content/Guns/Other/Weapon_LMG.cs");
}

// Animation functions
function TWAnimA(%obj)
{
	%obj.playThread(2, activate);
}

function TWAnimB(%obj)
{
	%obj.playThread(2, plant);
}

function TWAnimC(%obj)
{
	%obj.playThread(2, shifTo);
}

function TWAnimD(%obj)
{
	%obj.playThread(2, shiftleft);
}

function TWAnimE(%obj)
{
	%obj.playThread(2, shiftright);
}

function TWAnimF(%obj)
{
	%obj.playThread(2, shiftaway);
}

function TWAnimG(%obj)
{
	%obj.playThread(2, wrench);
}

function TWPlaySound(%obj, %sound)
{
	serverPlay3D(%sound, %obj.getPosition());
}